/**************************** fork.c **********************/
#define _POSIX_C_SOURCE  200112L
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

void message(char *s);

int main(int argc, char *argv[]){
    pid_t pid;
    int d;
    char tampon[10];
    int i;
    message("dbut du programme");

    d=open("toto",O_RDWR|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR);

    write(d,"qs",2);

    lseek(d,0,SEEK_SET);
    i=read(d,tampon,2);
    if( i<0 ){
      perror("avant fork");
      exit(EXIT_FAILURE);
    }

    tampon[i]='\0';
    printf("lu avant fork \"%s\"\n",tampon);
    


    pid = fork();
    if (pid == -1){ /* fork a echoue */
        perror(argv[0]);
        return EXIT_FAILURE;
    }
    else if (pid == 0){ /* processus enfant */
	lseek(d,0,SEEK_SET);
	i=read(d,tampon,2);
	if( i<0 ){
	  perror("read fils");
	  exit(EXIT_FAILURE);
	}
	tampon[i]='\0';
	printf("fils a lu \"%s\"\n",tampon);
	lseek(d,0,SEEK_SET);
	write(d,"ab",2);
	printf("fils a ecrit \"%s\"\n","ab");
	sleep(2);

	lseek(d,0,SEEK_SET);
	i=read(d,tampon,2);
	if( i<0 ){
	  perror("read fils");
	  exit(EXIT_FAILURE);
	}
	tampon[i]='\0';
	printf("fils a lu \"%s\"\n",tampon);
	message("fin fils");
    }
    else{              /* processus parent */
	lseek(d,0,SEEK_SET);
	i=read(d,tampon,2);
	tampon[i]='\0';
	printf("pere a lu \"%s\"\n",tampon);
	lseek(d,0,SEEK_SET);
	write(d,"wx",2);
	printf("pere a ecrit wx\n");
	sleep(2);
	lseek(d,0,SEEK_SET);
	i=read(d,tampon,2);
	tampon[i]='\0';
	printf("pere a lu \"%s\"\n",tampon);
	message("fin pere");
    }

    return EXIT_SUCCESS;
}

void message(char *s){
    printf("PID [%d] PPID [%d] : %s\n", 
	   (int) getpid(), (int) getppid(), s);
}
